/*++

  COPYRIGHT        (C) NEC        Corporation 1997

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author	:  		T.Hirata(NEC Software Ltd.,)
  Module Name:		kmapi.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'kmapi.h' define prototype of kamui function.

  Environment:
	Microsoft Compiler.

  Notes:
	define Kamui's api proto-types.

  Revision History:

--*/

#if !defined(__kamui_api_h)
#define __kamui_api_h

#ifdef __cplusplus
extern "C" {
#endif 




/*++
kmInitDevice

proto type:

	KMSTATUS
	kmInitDevice (KMVIDEOMODE nVideoMode);

Description:
	n[hEFÃCjVCYs܂B
	rfIMo͂ABLANKʂ\܂B

Arguments:
	IN	nVideoMode
		rfI[hw肵܂BL̂ꂩwł܂B

			KM_NTSC	... NTSCikāA{Ȃǁj
			KM_PAL	... PAL ([bpȂ)
			KM_VGA	... VGA (ARC1)

		ARC1ł́Aǂw肵ĂKM_VGAw肳ꂽ̂Ƃ݂Ȃ܂B



Result:

	KMSTATUS_SUCCESS				foCX
	KMSTATUS_INVALID_VIDEOMODE		sȃrfI[hw肵B
	KMSTATUS_HARDWARE_NOT_PRESENTED	n[hEFAgpłȂB

--*/
KMSTATUS KMAPI
kmInitDevice (
		IN	KMVIDEOMODE nVideoMode
	);


/*++
kmSetDisplayMode

proto type:

	KMSTATUS
	kmSetDisplayMode(
			IN	KMDISPLAYMODE	nDisplayMode,
			IN	KMBPPMODE		nBpp,
			IN	KMBOOLEAN		fDither,
			IN	KMBOOLEAN		fAntiAlias
		);

Description:
	Frame Buffer̕\[hݒ肵܂B

Arguments:
	IN	nDisplayMode
	fBXvC[hw肵܂B
		KM_DSPMODE_VGA				VGA(640x480) 60Hz
		KM_DSPMODE_NTSCNI320x240	320x240 mC^[X60Hz
		KM_DSPMODE_NTSCI320x240		320x240 C^[X 30Hz
		KM_DSPMODE_NTSCNI640x240	640x240 mC^[X60Hz
		KM_DSPMODE_NTSCI640x240		640x240 C^[X30Hz
		KM_DSPMODE_NTSCI640x480		640x480 C^[X 30Hz
		KM_DSPMODE_PALNI320x240		320x240 mC^[X50Hz
		KM_DSPMODE_PALI320x240		320x240 C^[X25Hz
		KM_DSPMODE_PALNI640x240		640x240 mC^[X50Hz
		KM_DSPMODE_PALI640x240	 	640x240 C^[X25Hz
		KM_DSPMODE_PALI640x480		640x480 C^[X25Hz

	IN	nBpp
	FrameBuffer̃J[[hw肵܂B
	ȉ̒`ςݒ萔gp邱Ƃł܂B
		KM_DSPBPP_RGB565		RGB565 
		KM_DSPBPP_RGB555		RGB555
		KM_DSPBPP_ARGB4444		ARGB4444
		KM_DSPBPP_ARGB1555		ARGB1555
		KM_DSPBPP_RGB888		RGB888
		KM_DSPBPP_ARGB8888		ARGB8888

	IN	bDither
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L肵܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB

	IN	bAntiAlias
		A`GAVOtB^̎gpۂ肵܂B
		A`GCAVOtB^Lɂꍇ쑬x
		ቺꍇ܂B
		
			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gp܂B


Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_DISPLAY_MODE	sȃfBXvC[hw肳ꂽB
									Ɏw肳ꂽfBXvC[h
									fBXvC[hw肳ꂽB


--*/

KMSTATUS KMAPI
kmSetDisplayMode(
		IN	KMDISPLAYMODE	nDisplayMode,
		IN	KMBPPMODE		nBpp,
		IN	KMBOOLEAN		fDither,
		IN	KMBOOLEAN		fAntiAlias
	);


/*++
kmChangeDisplayFilterMode

proto type:

	KMSTATUS 
	kmChangeDisplayFilterMode(	
			KMBOOLEAN fDither,
			KMBOOLEAN fAntiAlias
		);

Description:
	kmSetDisplayMode Őݒ肵fBUA`GAVOtB^ Enable / Disable 
	ŕύXׂɎgp܂B

Arguments:
	IN	bDither
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L肵܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB

	IN	bAntiAlias
		A`GAVOtB^̎gpۂ肵܂B
		A`GCAVOtB^Lɂꍇ쑬x
		ቺꍇ܂B
		
			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gp܂B



Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_DISPLAY_MODE	sȃfBXvC[hw肳ꂽB
									Ɏw肳ꂽfBXvC[h
									fBXvC[hw肳ꂽB

--*/

KMSTATUS  KMAPI
kmChangeDisplayFilterMode(	
		IN	KMBOOLEAN fDither,
		IN	KMBOOLEAN fAntiAlias
	);

/*++
kmCreateFrameBufferSurface

proto type:

	KMSTATUS 
	kmCreateFrameBufferSurface (
			PKMSURFACEDESC pSurfaceDesc,
			KMINT32 nWidth, 
			KMINT32 nHeight,
			KMBOOLEAN fStripBuffer,
			KMBOOLEAN fBufferClear
		);

Description:
	\pSurfacet[obt@ɃAP[gA
	܂B̊֐ĂяoOkmSetDisplayModesKv܂B

Arguments:
	OUT	pSurfaceDesc		KMSURFACEDESC \̗̂̈|C^łB
							kmCreateFrameBufferSurface ō쐬T[tBX̏񂪊i[܂B
							KMSTATUS  KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B


	IN	nWidth, nHeight		mۂ Surface̕^w肵܂B0,0ݒ肵ꍇɂ́AkmSetDisplayMode
							w肵ʃTCYgp܂B
							HOLLY Strip Buffergp邱Ƃł܂BStrip Buffergpꍇɂ́A
							nHeight  32̔{w肷Kv܂BStrip Buffer̋@\ARC1ɂ͂܂B
							ARC1Ŏgpꍇɂ͏0,0w肵ĂB


	IN	bStripBuffer		Strip Buffer ̍쐬Lw肵܂BStrip Buffer̋@\ARC1ɂ͂܂B
							ARC1Ŏgpꍇɂ͏FALSEw肵ĂB
							|ĂC邯ǁDDD
								TRUE		StripBuffer`̃t[obt@𐶐܂B 
								FALSE		Frame Buffer 𐶐܂B

	IN	bBufferClear		Frame Buffer 쐬ɏ̗Lw肵܂B
								TRUE	Surface쐬Ƃ0NA܂B
								FALSE	Sufrace0NA܂B

Result:
	KMSTATUS_SUCCESS				Frame Buffer 쐬
	KMSTATUS_NOT_ENOUGH_MEMORY		sAeʂȂ
	

--*/


KMSTATUS KMAPI
kmCreateFrameBufferSurface (
		OUT	PKMSURFACEDESC 	pSurfaceDesc,
		IN	KMINT32 		nWidth, 
		IN	KMINT32 		nHeight,
		IN	KMBOOLEAN 		fStripBuffer,
		IN	KMBOOLEAN 		fBufferClear
	);


/*++
kmCreateTextureSurface

proto type:
	KMSTATUS 
	kmCreateTextureSurface(
			PKMSURFACEDESC	pSurfaceDesc,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	eNX`pSurfacemۂ܂B

Arguments:
	OUT	pSurfaceDesc		KMSURFACEDESC \̗̂̈|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nWidth, nHeight		eNX`̉TCYAcTCYw肵܂B
								MIPMAPgpꍇɂ̓gbvx̃eNX`TCYw肵܂B
								Twiddled, VQ, PalettizedȂǂ̐`eNX`gpꍇɂ 
									nWidthɎw肵l݂̂gp܂B
								`eNX`gpꍇɂ́AnWidth, nHeightɗLłB
								ARC1AHOLLY͐`eNX`TCYƂ 8x8`1024x1024܂ł̃eNX`gpł܂A
								nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
								ꂩłȂ΂Ȃ܂B

	IN	nTextureType		eNX`̌`w肵܂B
							ȉ̃JeSR[hAsNZtH[}bgR[h
							IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_TWIDDLED			// TwiddledtH[}bg
									KM_TEXTURE_TWIDDLED_MM		// TwiddledtH[}bgMipmap
									KM_TEXTURE_VQ				// VQk`
									KM_TEXTURE_VQ_MM			// VQk`Mipmap
									KM_TEXTURE_PALETTIZE4		// 4bpppbg`
									KM_TEXTURE_PALETTIZE4_MM	// 4bpppbg`Mipmap
									KM_TEXTURE_PALETTIZE8		// 8bpppbg`
									KM_TEXTURE_PALETTIZE8_MM	// 8bpppbg`Mipmap
									KM_TEXTURE_RECTANGLE		// `

								- sNZtH[}bgR[h
									KM_TEXTURE_1555
									KM_TEXTURE_565
									KM_TEXTURE_4444
									KM_TEXTURE_YUV422
									KM_TEXTURE_BUMP
									KM_TEXTURE_8888

							)  KM_TEXTURE_8888KM_TEXTURE_PALETTIZE4or8Ƃ̑gݍ킹̂ݗLłB

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ
		KMSTATUS_INVALID_MIPMAPED_TEXTURE	MIPMAPłȂeNX`MIPMAPw肵B

--*/

KMSTATUS KMAPI
kmCreateTextureSurface(
		OUT	PKMSURFACEDESC	pSurfaceDesc,
		IN	KMINT32			nWidth, 
		IN	KMINT32			nHeight, 
		IN	KMTEXTURETYPE	nTextureType
	);

/*++
kmCreateCombinedTextureSurface

proto type:
	KMSTATUS 
	kmCreateCombinedTextureSurface(
			PKMSURFACEDESC	pSurfaceDesc1,
			PKMSURFACEDESC	pSurfaceDesc2,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	VQeNX`pSurfaceQmۂ܂BnTextureTypeɂɐݒ肷eNX`JeS
	KM_TEXTURE_VQ,KM_TEXTURE_VQ_MM̂ǂ炩łȂ΂Ȃ܂B

Arguments:
	OUT	pSurfaceDesc1		KMSURFACEDESC \̗̂̈P߂̃|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	OUT	pSurfaceDesc2		KMSURFACEDESC \̗̂̈Q߂̃|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nWidth, nHeight		eNX`̉TCYAcTCYw肵܂B
							MIPMAPgpꍇɂ̓gbvx̃eNX`TCYw肵܂B
							ARC1AHOLLY͐`eNX`TCYƂ 8x8`1024x1024܂ł̃eNX`gpł܂A
							nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
							ꂩłȂ΂Ȃ܂B

	IN	nTextureType		eNX`̌`w肵܂B
							ȉ̃JeSR[hAsNZtH[}bgR[h
							IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_VQ				// VQk`
									KM_TEXTURE_VQ_MM			// VQk`Mipmap

								- sNZtH[}bgR[h
									KM_TEXTURE_ARGB1555
									KM_TEXTURE_ARGB4444

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmCreateCombinedTextureSurface(
		OUT	PKMSURFACEDESC	pSurfaceDesc1,
		OUT	PKMSURFACEDESC	pSurfaceDesc2,
		IN	KMINT32			nWidth, 
		IN	KMINT32			nHeight, 
		IN	KMTEXTURETYPE	nTextureType
	);


/*++
kmSetAlphaThreshold

proto type:

	KMSTATUS 
	kmSetAlphaThreshold(	
			KMINT32 nThreshold	
		);

Description:
	1555T[tFX_OpSurfaceƂꍇɃ1bit肷邽߂̃XbVhlłB
	_OʂAŃZbglȏƂȂꍇArbg1ɂ܂B
	rbgRAMDACȂǂŃN}L[ꍇɎgp܂B

Arguments:
	IN	nThreshold		0`255̒l̃XbVhlB
						0ȉ܂255ȏw肳ꂽꍇ́Aꂼ0A255 ɃNv܂B


Result:
	KMSTATUS_SUCCESS		ݒ萬
--*/

KMSTATUS KMAPI
kmSetAlphaThreshold(	
		IN	KMINT32 nThreshold	
	);

/*++
kmActivateFrameBuffer

proto type:

	KMSTATUS 
	kmActivateFrameBuffer(
			PKMSURFACEDESC	pPrimarySurfaceDesc,
			PKMSURFACEDESC	pBackBufferSufaceDesc, 
			KMBOOLEAN 		fStripBuffer,
			KMBOOLEAN 		fWaitVSync
		);

Description:
	t[obt@̕\Jn܂B
Arguments:

	IN	pPrimarySurfaceDesc		\ɎgpSurfaceSurface\̂łB 
								kmCreateFrameBufferSurface Surfacemۂ_œꂽ
								Surface\̂ݒ肵ĂB

	IN	pBackBufferSurfaceDesc	_OΏSurfaceSurface\̂łB

	IN	bStripBuffer			StripBuffergpꍇTRUEw肵܂B
	IN	bWaitVSync				Surface̕\Vsync܂Wait邩ǂw肵܂B
								TRUȄꍇ{֐Vsync^C~O܂ŃEFCgA
								\Jn܂B


Result:
	KMSTATUS_SUCCESS			\؂ւ

--*/

KMSTATUS KMAPI
kmActivateFrameBuffer(
		IN	PKMSURFACEDESC	pPrimarySurfaceDesc,
		IN	PKMSURFACEDESC	pBackBufferSufaceDesc, 
		IN	KMBOOLEAN		fStripBuffer,
		IN	KMBOOLEAN		fWaitVSync
	);

/*++
kmFlipFrameBuffer

proto type:

	KMSTATUS
	kmFlipFrameBuffer( KMVOID );

Description:
	t[obt@_uobt@OꍇɁA\pPrimarySurface
	_O^[Qbg BackBuffer ւ܂B
	FlipR}h̓L[COAFlipsꂽVsync^C~O BackBuffer ւ
	_OIĂꍇAFlips܂B
	ȂAStripBuffergpɂ́A\tgEFAɂFlip͕Kv܂B

Arguments:
		none

Result:
		KMSTATUS_SUCCESS			FlipR}hs
		KMSTATUS_CANT_FLIP_SURFACE 	FlipR}hss

--*/
KMSTATUS KMAPI
kmFlipFrameBuffer( KMVOID );

/*++
kmSetWaitVsyncCount

proto type:

	KMSTATUS
	kmSetWaitVsyncCount( KMINT32 nCount );

Description:
		

Arguments:
		IN	nCount		V-Sync ҂񐔂w肵܂BO FlipA
						Flip \ɂȂ܂łV-Syncw肵܂B

Result:
		KMSTATUS_SUCCESS			
--*/
KMSTATUS KMAPI
kmSetWaitVsyncCount(
		IN	KMINT32 nCount 
		);


/*++
kmSetCullingRegister

proto type:

	KMSTATUS
	kmSetCullingRegister(
			KMFLOAT fCullVal
		);

Description:
	|Sɑ΂JÕXbVhlws܂B

Arguments:
		IN	fCullVal	ʃp[^̃f^~iglݒ肵܂B

Result:
		KMSTATUS_SUCCESS			FlipR}hs
		KMSTATUS_CANT_FLIP_SURFACE 	FlipR}hss

--*/

KMSTATUS KMAPI
kmSetCullingRegister(
		IN	KMFLOAT fCullVal
	);


/*++
kmSetColorClampValue

proto type:

	KMSTATUS
	kmSetColorClampValue(
			KMPACKEDARGB MaxVal,
			KMPACKEDARGB MinVal 
		);

Description:
	J[̃Nvlw肵܂BJ[Nv̓tHȎOiŊ|܂B
	_OɃNvFύXƂɂ́A
	K_OĨR[obN֐ȂǂŕύXsĂB
	ȊÕ^C~OŕύXsꍇAʃC[WsƂȂꍇL܂B

Arguments:
	IN	MaxVal			Packed ARGB 32bitJ[ŁANv̍őlw肵܂B
						Px128RGBFw肷ꍇ0x00808080̂悤Ɏw肵܂B

	IN	MinVal			Packed ARGB 32bitJ[ŁANv̍őlw肵܂B
						Px20RGBFw肷ꍇ0x00141414̂悤Ɏw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetColorClampValue(
		IN	KMPACKEDARGB MaxVal,
		IN	KMPACKEDARGB MinVal 
	);

/*++
kmSetFogTableColor

proto type:

	KMSTATUS
	kmSetFogTableColor(
			KMPACKEDARGB FogTableColor
		);

Description:
	tHOJ[w肵܂BHOLLYłFogVertexAFogTableɕʁX̃tHOJ[wł܂A
	ARC1ł͓̂FogVertexAFogTableɕʁX̒lݒ肵ĂAォݒ肳ꂽlLƂȂ܂B
	_OɃtHOJ[ύXƂɂ́AK_OĨR[obN֐ȂǂŕύX
	sĂBȊÕ^C~OŕύXsꍇAʃC[WsƂȂꍇ܂B

Arguments:
	IN	FogTableColor		FogTable ɎgpPacked32bitJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetFogTableColor(
		KMPACKEDARGB FogTableColor
	);

/*++
kmSetFogVertexColor

proto type:

	KMSTATUS 
	kmSetFogVertexColor(
			KMPACKEDARGB FogVertexColor
		);

Description:
	tHOJ[w肵܂BHOLLYłFogVertexAFogTableɕʁX̃tHOJ[wł܂A
	ARC1ł͓̂FogVertexAFogTableɕʁX̒lݒ肵ĂAォݒ肳ꂽlLƂȂ܂B
	_OɃtHOJ[ύXƂɂ́AK_OĨR[obN֐ȂǂŕύX
	sĂBȊÕ^C~OŕύXsꍇAʃC[WsƂȂꍇ܂B

Arguments:
	IN	FogVertexColor		FogVertexɎgpPacked32bitJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS  KMAPI
kmSetFogVertexColor(
		IN	KMPACKEDARGB FogVertexColor
	);

/*++
kmSetFogTable

proto type:

	KMSTATUS
	kmSetFogTable(
			PKMFLOAT pfFogTable
		);

Description:
	FogTableo^܂B256iKfloatl̊i[ꂽzւ̃|C^Ƃēn܂B
	

Arguments:
	IN	pfFogTable	tHOe[ulzւ̃|C^B256iK̃p[^w肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetFogTable(
		IN	PKMFLOAT pfFogTable
	);

/*++
kmSetFogDensity

proto type:

	KMSTATUS
	kmSetFogDensity(KMDWORD fogDensity)

Description:
	TSP Fog ̌W^B

Arguments:
	IN	fogDensity			TSP Fog ̌W

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS	KMAPI
kmSetFogDensity(
		IN	KMDWORD fogDensity
	);

/*++
kmSetPaletteMode

proto type:

	KMSTATUS 
	kmSetPaletteMode(	
			KMPALETTEMODE Palettemode
		);

Description:
	I`bvpbg̃[hw܂B

Arguments:
	IN	PaletteMode		pbg BPP [h
						KM_PALETTE_16BPP	16BPP[h 565, 555, 1555, 4444gp܂B
						KM_PALETTE_32BPP 	32BPP[h 8888gp܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS  KMAPI
kmSetPaletteMode(	
		IN	KMPALETTEMODE Palettemode
	);

/*++
kmSetPaletteData

proto type:
	KMSTATUS
	kmSetPaletteData(
			PKMPALETTEDATA pPaletteTable
		);

Description:
	I`bvpbg̐ݒs܂B

Arguments:
	IN	pPaletteTable	Paletteݒpz̃|C^w肵܂B
						Paletteݒpz̓e͈ȉ̂悤ɂȂ܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetPaletteData(
		IN	PKMPALETTEDATA pPaletteTable
	);

/*++
kmSetBorderColor

proto type:
	KMSTATUS
	kmSetBorderColor(
			KMPACKEDARGB BorderColor
		);

Description:
	{[_[i\ʊO̕jJ[̐ݒs܂B

Arguments:
	IN	BorderColor		PackedARGBJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetBorderColor(
		IN	KMPACKEDARGB BorderColor
	);

/*++
kmSetBackGroundRenderState

proto type:
	KMSTATUS
	kmSetBackGroundRenderState(
			PKMVERTEXCONTEXT	pVertexContext
		);

Description:
	kmProcessVertexRenderState Őݒ肵 KMVERTEXCONTEXT ́A
	GLOBALPARAMBUFFER , ISPPARAMBUFFER , TSPPARAMBUFFER , 
	TexturePARAMBUFFER oA Background Plane ̃_O
	p[^ƂăVXeɓo^Bȍ~ kmSetBackGroundPlane ̐ݒ́A
	Őݒ肵 KMVERTEXCONTEXT ̒lLɂȂB

Arguments:
	IN	pVertexContext
						Vertex Context ւ̃|C^^B

Result:
	KMSTATUS_SUCCESS	ݒ萬

--*/

KMSTATUS KMAPI
kmSetBackGroundRenderState(
		PKMVERTEXCONTEXT	pVertexContext
	);

/*++
kmSetBackGroundPlane

proto type:
	KMSTATUS
	kmSetBackGroundPlane(
				PVOID			pVertex[3],
				KMVERTEXTYPE	VertexType,
				KMINT32			StructSize
			);

Description:
	obNOEhʂ̐ݒs܂B
	̑OɁAkmSetBackGroundRenderState ĂяoKvB

Arguments:
	IN	pVertex[3]		obNOEhv[̍W_f[^\̂ւ̃|C^
						ڍׂ́A kmSetVertex Q

	IN	VertexType		_f[^̃f[^^CvB
						ڍׂ kmSetVertex Q
	IN	StructSize		_f[^̃f[^^CvB
						ڍׂ kmSetVertex Q

Result:
	KMSTATUS_SUCCESS			ݒ萬

--*/

KMSTATUS KMAPI
kmSetBackGroundPlane(
			PVOID			pVertex[3],
			KMVERTEXTYPE	VertexType,
			KMINT32			StructSize
		);

/*++
kmSetAutoSortMode

proto type:
	KMSTATUS
	kmSetAutoSortMode(
			KMBOOLEAN fEnable
		);

Description:
	ʂ̃I[g\[g[hON/OFF𐧌䂵܂B

Arguments:
	IN	bEnable		Auto Sort mode ̗LtO
				TRUE	ʂ̃\[gɃI[g\[g[hݒ肵܂B
				FALSE	]^Ɠ\tgEFAɂ\[eBOG~[V܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetAutoSortMode(
		IN	KMBOOLEAN fEnable
	);

/*++
kmSetPixelClipping

proto type:
	KMSTATUS
	kmSetPixelClipping(
				KMINT32	Xmin,
				KMINT32	Ymin,
				KMINT32	Xmax,
				KMINT32	Ymax
			);

Description:
	t[obt@ւ̃_Ȍo͂ɑ΂AsNZPʂ̃NbsOݒ肵܂B

Arguments:
	IN	Xmin, Ymin, Xmax, Ymax
				sNZPʂ̃NbsÖ̍AEWw肵܂B
				(Xmin,Ymin)-(Xmax,Ymax)́AʃTCY菬Ȃ΂܂B
				܂Aʃ[h24bpp̎́ANbsÖ̍W͋łȂ΂܂
				iȂ킿QsNZPʂłNbsÖݒł܂jB
				łȂꍇɂ́A(Xmin,Ymin)ɑ΂Ă͎wP傫lA
										(Xmax,Ymax)ɑ΂Ă͎wPlݒ肳܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALID_PARAMETER	p[^s

--*/

KMSTATUS KMAPI
kmSetPixelClipping(
		IN	KMINT32	Xmin,
		IN	KMINT32	Ymin,
		IN	KMINT32	Xmax,
		IN	KMINT32	Ymax
	);

/*++
kmSetPixelClipping

proto type:
	KMSTATUS
	kmSetStrideWidth(
			KMINT32 nWidth
		);

Description:
	XgCheNX`̃XgChTCYw肵܂BXgChTCÝA
	RQ̔{łȂ΂ȂȂB

Arguments:
	IN	nWidth		XgChTCY͂B
					XgChTCY 32̔{łȂ΂ȂȂB

Result:
	KMSTATUS_SUCCESS			ݒ萬
	KMSTATUS_INVALID_PARAMETER	p[^s

--*/

KMSTATUS KMAPI
kmSetStrideWidth(
		KMINT32 nWidth
	);


/*++
kmSetForwardClipping

proto type:

	KMSTATUS
	kmSetForwardClipping(
			IN	KMFLOAT fDepth
		);

Description:
	OʃNbsOݒ肵܂B fDepth ̒l̏ꍇɂ́A
	l͖ANbsO͍sȂB܂A1/w  IEEE 754
	̐xE𒴂̈ł̃NbsO͍s܂B
	{ݒ̓jANbvŝł͂܂̂ŁA_ 1/w 
	Wlɑ傫Ƃ̃jANbv́AAvP[V
	sKvB

Arguments:
	IN	fDepth
		OʃNbsO Depthlݒ肵܂B

Result:

	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmSetForwardClipping(
		IN	KMFLOAT fDepth
		);



/*++
kmResetRenderer

proto type:

	KMSTATUS
	kmResetRenderer( VOID );

Description:
	_OpCvC̃\tgEFAZbgsB

	gpꍇF
		EStripBuffergpɃXgbṽf[^`Ȃ
		  ꍇ̋ZbgB

Arguments:
	NONE

Result:

	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmResetRenderer( VOID );

/*++
kmProcessVertexRenderState

proto type:
	KMSTATUS
	kmProcessVertexRenderState(
				PKMVERTEXCONTEXT pVertexContext
			);

Description:
	_iXgbvjƂɗLƂȂ郌_Op[^ݒ肵܂B
	pVertexContextŐݒ肳ꂽݒlVXeɓo^邽߂̑Os܂B
	_Strip̓o^sOɕKsĂB
	{֐ĂяoƂŁAKMVERTEXCONTEXT̊eo
			Global Parameter, 
			Combined ISP/TSP Instruction Word, 
			TSP Control Word, 
			Texture Control Bits𐶐A

	KMVERTEXCONTEXT
		GLOBALPARAMBUFFER, 
		ISPPARAMBUFFER, 
		TSPPARAMBUFFER, 
		TexturePARAMBUFFER
	oɐݒ肵܂B̊֐Ăяo
	kmSetVertexRenderStateĂяoƂł̒lVXeɓo^܂B

Arguments:
	IN	pVertexContext		ReLXgւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALIDSETTING	ĂȂ[hݒ

--*/

KMSTATUS KMAPI
kmProcessVertexRenderState(
		IN	PKMVERTEXCONTEXT pVertexContext
	);

/*++
kmSetVertexRenderState

proto type:

	KMSTATUS
	kmSetVertexRenderState (
			PKMVERTEXCONTEXT pVertexContext
		);

Description:
	kmProcessVertexRenderStateŐݒ肵 KMVERTEXCONTEXT ̈ȉ̃oAVXeɓo^܂B
	ȍ~̒_Stripo^ł́AŎw肵KMVERTEXCONTEXTLƂȂ܂B
					- GLOBALPARAMBUFFER
					- ISPPARAMBUFFER
					- TSPPARAMBUFFER
					- TexturePARAMBUFFER

Arguments:
	IN	pVertexContext		ReLXgւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS		_Op[^o^

--*/


KMSTATUS KMAPI
kmSetVertexRenderState (
		IN	PKMVERTEXCONTEXT pVertexContext
	);

/*++
kmSetModifierRenderState

proto type:
	KMSTATUS
	kmSetModifierRenderState(
			PKMVERTEXCONTEXT	pVertexContext
		);

Description:
	kmProcessVertexRenderStateŐݒ肵KMVERTEXCONTEXT 
	ȉ̃oAft@CA{[gp|ŚA
	QԖڂ̃_Op[^ƂăVXeɓo^܂B
			TSPPARAMBUFFER
			TexturePARAMBUFFER

	ȍ~̃ft@CA{[gp|S̒_Stripo^ł́A
	Ŏw肵KMVERTEXCONTEXTQԖڂ̃_Op[^ƂĎgp܂B

		KMVERTEXCONTEXT\̂̂ȉ̃o͖ƂȂ܂B
		(kmSetVertexRenderStateł̐ݒlLƂȂ܂)
		// for Global Parameter
		KMPARAMTYPE			ParamType			// Parameter Type
		KMLISTTYPE			ListType			// List Type
		KMCOLORTYPE			ColorType			// Color Type
		KMUVFORMAT			UVFormat			// UV format

		// for ISP/TSP Instruction Word
		KMDEPTHMODE			DepthMode;			// DepthModew
		KMCULLINGMODE		CullingMode;		// Culling Mode
		KMSCREENCORDINATION	ScreenCoordination;	// Screen Coordination
		KMSHADINGMODE		ShadingMode;		// Shading Mode
		KMMODIFIER			SelectModifier;		// Modifier Volume Valiant
		KMBOOLEAN			fZWriteDisable;		// Z Write Disable

Arguments:
	IN	pVertexContext		_OReLXgւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS		_Op[^o^


--*/

KMSTATUS KMAPI
kmSetModifierRenderState(
		IN	PKMVERTEXCONTEXT	pVertexContext
	);

/*++
kmSetGlobalClipping

proto type:
	KMSTATUS
	kmSetGlobalClipping(
				KMINT32 nWidth, 
				KMINT32 nHeight
			);
Description:
	O[oNbsÖw肵܂B0,0IWWidthAHeightŎw肳ꂽ
	̈ȊÔƂɂ̓_O܂B

Arguments:
	IN	nWidth, nHeight				^CTCY̔{w肵܂B
									HOLLY̏ꍇ32x32̃^CTCŶ߁A
									Ƃ128x64̗̈w肵ꍇɂ Width = 4,Height= 2Ƃ܂B
									ARC1̏ꍇ32x8̃^CTCYłA 
									HOLLYł̃p[^w_ГARC1ɍ킹ĕϊ(Height~4)܂B

Result:
	KMSTATUS_SUCCESS					ݒ萬
	KMSTATUS_INVALID_PARAMETER			ݒ莸s

--*/

KMSTATUS KMAPI
kmSetGlobalClipping(
		IN	KMINT32 nWidth, 
		IN	KMINT32 nHeight
	);

/*++
kmUseAnotherModifier

proto type:
	KMSTATUS
	kmUseAnotherModifier(
			KMLISTTYPE kmModifierListType
			);

Description:
	kmModifierListType Ŏw肵 Modifier 𑼕 
	Modifier ƂĂgpB

Arguments:
	IN	kmModifierListType		KM_OPAQUE_MODIFIER	Opaque Modifier  Trans Modifier  ƂĎgpB
								KM_TRANS_MODIFIER	Trans Modifier   Opaque Modifier ƂĎgpB

Result:
	KMSTATUS_SUCCESS				ݒ萬
	KMSTATUS_INVALID_LIST_TYPE		ݒ莸s

--*/

KMSTATUS KMAPI
kmUseAnotherModifier(
		IN	KMLISTTYPE kmModifier
			);

/*++
kmSetCheapShadowMode

proto type:
	KMSTATUS
	kmSetCheapShadowMode(
			KMFLOAT fIntensity
			);

Description:
	`[vVhE[hI܂B̊֐Œlݒ肳ꂽAׂĂModifierVolumeݒ̓`[vVhE[h
	ɐݒ肳܂BQp[^{[Ƃ̋͂ł܂BCheapShadowModeIɂ͈ɕ̒lāA
	̊֐ĂяoKv܂B

Arguments:
	IN	fIntensity				ft@CA{[ɓ|S̋Pxݒ肵܂B0.25A0.5A0.75̒l
								邱Ƃł܂BȊO̐̒l͂ꂽꍇɂ́A̒l𒴂ȂAL̒lɊۂ߂܂B
								܂A̒l͂ꍇACheapShadowMode̐ݒIAʏ̂Qp[^|SLɂȂ܂B

Result:
	KMSTATUS_SUCCESS					ݒ萬
	KMSTATUS_INVALID_PARAMETER			p[^s

--*/

KMSTATUS KMAPI
kmSetCheapShadowMode(
		IN	KMFLOAT fIntensity
			);

/*++
kmSetStripLength

proto type:
	KMSTATUS
	kmSetStripLength(
			KMLISTTYPE		ListType,
			KMSTRIPLENGTH	StripLength
		);

Description:
	͂ꂽ_Xgbvf[^An[hEFAŁA
	|S̃Xgbvɕ邩w肵܂B
	ȍ~̒_Stripo^ł́AŎw肵XgbvLƂȂ܂B
	ARC1ł́An[hEFAł́AɃXgbvPɕ܂B
	iIɂ́Å֐sꂽ́Aw肳ꂽXg^Cvł̍ŏ̒_f[^o^ɁA
	̃O[op[^Strip_Lenݒ肵܂Bj
Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE		KM_OPAQUE_POLYGON	= 0	// s|S
										KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
										KM_TRANS_POLYGON	= 2	// ^|S
										KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

	IN	StripLength		ȉ̂ꂩwł܂B
						KMSTRIPLENGTH
							KM_STRIP_01		= 0		// Xgbv1ɕ܂B
							KM_STRIP_02 	= 1 	// Xgbv2ɕ܂B
							KM_STRIP_04		= 2 	// Xgbv4ɕ܂B
							KM_STRIP_06 	= 3		// Xgbv6ɕ܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetStripLength(
		IN	KMLISTTYPE		ListType,
		IN	KMSTRIPLENGTH	StripLength
	);

/*++
kmSetUserClipping

proto type:
	KMSTATUS
	kmSetUserClipping(
			KMLISTTYPE ListType,
			KMUSERCLIPMODE ClipMode,
			KMINT32	Xmin,
			KMINT32	Ymin,
			KMINT32	Xmax,
			KMINT32 Ymax 
		);

Description:
	[U[NbsÖݒ肵܂Bȍ~̒_Stripo^ł́A
	Ŏw肵[U[NbsÖ悪LƂȂ܂
	iIɂUser Tile ClipControl ParameterA
	w肳ꂽXg^Cv̒_f[^obt@ɐς݂܂jB

ӁF kmStartVertexStripkmSetVertex̊ԂŁA kmSetUserClipping𔭍sĂ͂܂B

Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE	KM_OPAQUE_POLYGON	= 0	// s|S
									KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
									KM_TRANS_POLYGON	= 2	// ^|S
									KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

	IN	ClipMode		ȉ̂ꂩwł܂B
						KMUSERCLIPMODE	KM_USERCLIP_DISABLE	= 0	// [U[Nbv𖳌ɂ܂B
										KM_USERCLIP_RESERVE	= 1	// ͎w肵ȂłB
										KM_USERCLIP_INSIDE	= 2	// w肵̈̓̂ݗLƂȂ܂B
										KM_USERCLIP_OUTSIDE	= 3	// w肵̈̊ÔݗLƂȂ܂B

	IN	Xmin, Ymin, Xmax, Ymax
						[U[Nbv̈̍AEWw肵܂B 
						Ŏw肷l̓^CPʂłB(1 = 32pixel)
						Xmin,Xmax́A7bit̂ݗLłB
						Ymin,Ymax́A4bit̂ݗLłB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetUserClipping(
		IN	KMLISTTYPE 		ListType,
		IN	KMUSERCLIPMODE	ClipMode,
		IN	KMINT32			Xmin,
		IN	KMINT32			Ymin,
		IN	KMINT32			Xmax,
		IN	KMINT32			Ymax
	);

/*++
kmSetUserClippingDirect

proto type:
	KMSTATUS
	kmSetUserClippingDirect(
			KMUSERCLIPMODE ClipMode,
			KMINT32	Xmin, 
			KMINT32	Ymin,
			KMINT32	Xmax, 
			KMINT32	Ymax
		);

Description:
	[U[NbsÖݒ肵܂Bȍ~̒_Stripo^ł́A
	Ŏw肵[U[NbsÖ悪LƂȂ܂B 
	kmSetUserClippingƂ̈ႢɂĂ3.6͂QƂĂB
	iIɂUser Tile ClipControl ParameterA gvi^CANZ[^j֒ڏ݂܂Bj

ӁF kmStartVertexStripDirectkmSetVertexDirect̊ԂŁA kmSetUserClippingDirect𔭍sĂ͂܂B

Arguments:
	IN	ClipMode		ȉ̂ꂩwł܂B
						KMUSERCLIPMODE	KM_USERCLIP_DISABLE	= 0	// [U[Nbv𖳌ɂ܂B
										KM_USERCLIP_RESERVE	= 1	// ͎w肵ȂłB
										KM_USERCLIP_INSIDE	= 2	// w肵̈̓̂ݗLƂȂ܂B
										KM_USERCLIP_OUTSIDE	= 3	// w肵̈̊ÔݗLƂȂ܂B

	IN	Xmin, Ymin, Xmax, Ymax
						[U[Nbv̈̍AEWw肵܂B 
						Ŏw肷l̓^CPʂłB(1 = 32pixel)
						Xmin,Xmax́A7bit̂ݗLłB
						Ymin,Ymax́A4bit̂ݗLłB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetUserClippingDirect(
		IN	KMUSERCLIPMODE ClipMode,
		IN	KMINT32	Xmin, 
		IN	KMINT32	Ymin,
		IN	KMINT32	Xmax, 
		IN	KMINT32	Ymax
	);

/*++
kmGetCurrentVertexOffset

proto type:
	KMDWORD
	kmGetCurrentVertexOffset(
			KMLISTTYPE ListType
		);

Description:
	݁Aw̃Xg^CvVertexBufferŒ_f[^XgAĂ32rbg[hԂlƂĕԂ܂B
	{֐œlAkmChangeVertexOffsetkmChangeVertexPCWƑgݍ킹Ďgp邱ƂɂAVertexBuffer̒l
	ύX邱Ƃł܂B

Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE	KM_OPAQUE_POLYGON	= 0	// s|S
									KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
									KM_TRANS_POLYGON	= 2	// ^|S
									KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

Result:
	w胊Xg^Cv݂݈̌̏ʒuԂ܂Bl͎w胊Xg^CvVertexBuffeŕAŏ̃|C^
	32bit[hItZbgl(݂̎w胊Xg^CvVertexBuffer̎gpe)łB

--*/

KMDWORD KMAPI
kmGetCurrentVertexOffset(
		KMLISTTYPE ListType
	);

/*++
kmChangeVertexOffset

proto type:
	KMSTATUS
	kmChangeVertexOffset(
			KMLISTTYPE ListType,
			KMDWORD    VertexOffset
		);

Description:
	w胊Xg^CvVertexBuffeŕȀ݂݈ʒuύX܂B
	
Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE	KM_OPAQUE_POLYGON	= 0	// s|S
									KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
									KM_TRANS_POLYGON	= 2	// ^|S
									KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

	IN	VertexOffset	w胊Xg^Cv݈̏ʒuw肵܂BkmGetCurrentVertexOffsetȂǂŎ擾lgp܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALID_VALUE	włȂlݒ肵

--*/

KMSTATUS KMAPI
kmChangeVertexOffset(
		KMLISTTYPE ListType,
		KMDWORD    VertexOffset
	);

/*++
kmChangeVertexPCW

proto type:
	KMSTATUS
	kmChangeVertexPCW(
			KMLISTTYPE ListType,
			KMDWORD    VertexPCW,
			KMDWORD    IncPtr
		);

Description:
	w̃Xg^CvVertexBuffeŕȀ݂݈ʒuVertexPCWŎw肳ꂽl݂܂B̏ꍇ
	VertexBuffer̃|C^IncPtrACNg܂BOp`̃Xgbv`IArŃXgbv
	fꍇȂǂɎgp܂B{֐VertexBuffer̐j󂷂\܂̂Ŏgpꍇɂ͏\
	ӂĂB܂AVertex`Directn̊֐gpĂꍇɂ͎gpł܂B

Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE	KM_OPAQUE_POLYGON	= 0	// s|S
									KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
									KM_TRANS_POLYGON	= 2	// ^|S
									KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

	IN	VertexPCW		_`ParameterControlWordw肵܂B
									KM_VERTEXPARAM_NORMAL		= 0xE0000000	// ʏ̒_f[^
									KM_VERTEXPARAM_ENDOFSTRIP	= 0xF0000000	// XgbvI[̒_f[^

	IN	IncPtr			VertexPCWŎw肳ꂽp[^݌ɁAVertexBuffer̃|C^i߂̂w肵܂B
						ʏsizeof(...)/4̂悤ɎgpĂVertexTypẽTCYw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmChangeVertexPCW(
		KMLISTTYPE ListType,
		KMDWORD    VertexPCW,
		KMDWORD    IncPtr
	);

/*++
kmChangeContextColorType

proto type:
	KMSTATUS
	kmChangeContextColorType(
			KMCOLORTYPE Color
		);

Description:
	_̃J[tH[}bgύX܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextColorType(
		KMCOLORTYPE Color
	);

/*++
kmChangeContextDepthMode

proto type:
	KMSTATUS 
	kmChangeContextDepthMode(
			KMDEPTHMODE DepthMode
		);

Description:
	Zlr[hI܂B

Arguments:

Result:

--*/

KMSTATUS  KMAPI
kmChangeContextDepthMode(
		KMDEPTHMODE DepthMode
	);

/*++
kmChangeContextCullingMode

proto type:
	KMSTATUS
	kmChangeContextCullingMode(
			KMCULLINGMODE CullingMode
		);

Description:
	JO[hI܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextCullingMode(
		KMCULLINGMODE CullingMode
	);

/*++
kmChangeContextZwriteDisable

proto type:
	KMSTATUS
	kmChangeContextZwriteDisable(
			KMBOOLEAN fZwriteDisable
		);

Description:
	Zl̍XV֎~/܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextZwriteDisable(
		KMBOOLEAN fZwriteDisable
	);

/*++
kmChangeContextSRCBlendMode

proto type:
	KMSTATUS
	kmChangeContextSRCBlendMode(
			KMBLENDINGMODE SRCBlend
		);

Description:
	\[X̃ufBO[hI܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextSRCBlendMode(
		KMBLENDINGMODE SRCBlend
	);

/*++
kmChangeContextDSTBlendMode

proto type:
	KMSTATUS
	kmChangeContextDSTBlendMode(
			KMBLENDINGMODE DSTBlend
		);

Description:
	fBXel[ṼufBO[hI܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextDSTBlendMode(
		KMBLENDINGMODE DSTBlend
	);

/*++
kmChangeContextFogMode

proto type:
	KMSTATUS
	kmChangeContextFogMode(
			KMFOGMODE FogMode
		);

Description:
	tHO[hI܂B

Arguments:

Result:

--*/


KMSTATUS KMAPI
kmChangeContextFogMode(
		KMFOGMODE FogMode
	);

/*++
kmChangeContextFlipUV

proto type:
	KMSTATUS
	kmChangeContextFlipUV(
			KMFLIPMODE FlipMode
		);

Description:
	eNX`Flipݒ肵܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextFlipUV(
		KMFLIPMODE FlipMode
	);

/*++
kmChangeContextClampUV

proto type:
	KMSTATUS
	kmChangeContextClampUV(
			KMCLAMPMODE ClampMode
		);

Description:
	eNX`Clampݒ肵܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextClampUV(
		KMCLAMPMODE ClampMode
	);

/*++
kmChangeContextFilterMode

proto type:
	KMSTATUS
	kmChangeContextFilterMode(
			KMFILTERMODE FilterMode
		);

Description:
	eNX`tB^ݒ肵܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextFilterMode(
		KMFILTERMODE FilterMode
	);

/*++
kmChangeContextSuperSample

proto type:
	KMSTATUS
	kmChangeContextSuperSample(
			KMBOOLEAN fEnable
		);

Description:
	TRUȄꍇanisotoropic Filtergp܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextSuperSample(
		KMBOOLEAN fEnable
	);

/*++
kmChangeContextTextureShadingMode

proto type:
	KMSTATUS
	kmChangeContextTextureShadingMode(
			KMTEXTURESHADINGMODE TexShadingmode
		);

Description:
	eNX`ufBO[hw肵܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextTextureShadingMode(
		KMTEXTURESHADINGMODE TexShadingmode
	);

/*++
kmChangeContextColorClamp

proto type:
	KMSTATUS
	kmChangeContextColorClamp(
			KMBOOLEAN fColorClamp
		);

Description:
	TRUȄꍇO[oWX^̒lɏ]ĐFNv܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextColorClamp(
		KMBOOLEAN fColorClamp
	);

/*++
kmChangeContextPaletteBank

proto type:
	KMSTATUS
	kmChangeContextPaletteBank(
			KMDWORD Bank
		);

Description:
	݂̃pbgoNύX܂B

Arguments:

Result:

--*/

KMSTATUS KMAPI
kmChangeContextPaletteBank(
		KMDWORD Bank
	);

/*++
kmCreateVertexBuffer

proto type:
	KMSTATUS
	kmCreateVertexBuffer(
			PKMVERTEXBUFFDESC pBufferDesc,
			KMINT32 OpaquePolygonBuffer,
			KMINT32 OpaqueModifierBuffer,
			KMINT32 TransPolygonBuffer,
			KMINT32 TransModifierBuffer
		);

Description:
	CɁA_f[^o^ɎgpS̃obt@i_uobt@jmۂ܂B
	܂AɌK؂ȃTCÝA^CANZ[^o͗pobt@(Native Data Buffer)
	t[obt@Ɋmۂ܂B
	̏ꍇ̒_f[^o^́A kmStartVertexStrip, kmSetVertex, kmRendergp
	S̃obt@ւPV[̃f[^o^A܂Ƃ߂Ăgv֑邱ƂɂĎ܂B
	ЂƂ̃AvP[VkmCreateVertexBufferkmCreateTABuffer𓯎Ɏgp邱Ƃ͂ł܂B

Arguments:
	I/O	pBufferDesc		PKMVERTEXBUFFDESC^́A_obt@fXNv^ւ̃|C^͂܂B
						_obt@fXNv^̊eoɂ́AŃAP[gꂽ
						S̃obt@̐擪AhXԂ܂B

	IN	OpaquePolygonBuffer
						s|Sςݏグ钸_f[^obt@̃TCYioCgjB

	IN	OpaqueModifierBuffer
						sft@CA{[ςݏグ钸_f[^obt@̃TCYioCgjB

	IN	TransPolygonBuffer
						^|Sςݏグ钸_f[^obt@̃TCYioCgjB

	IN	TransModifierBuffer
						^ft@CA{[ςݏグ钸_f[^obt@̃TCYioCgjB


Result:
	KMSTATUS_SUCCESS			_f[^obt@mې
	KMSTATUS_NOT_ENOUGH_MEMORY	eʂȂ

--*/

KMSTATUS KMAPI
kmCreateVertexBuffer(
		IN	PKMVERTEXBUFFDESC pBufferDesc,
		IN	KMINT32 OpaquePolygonBuffer,
		IN	KMINT32 OpaqueModifierBuffer,
		IN	KMINT32 TransPolygonBuffer,
		IN	KMINT32 TransModifierBuffer
	);

/*++
kmDiscardVertexBuffer

prototype:
KMSTATUS KMAPI
kmDiscardVertexBuffer(
		PKMVERTEXBUFFDESC pBufferDesc
	);

Description:
	kmCreateVertexBuffer ŁAmۂ_f[^o^p̂S̃obt@(Double Buffer)
	J܂B܂AƓɁAmۂꂽ^CANZ[^o͗pobt@
	(Native Data Buffer)J܂B

Argument:
	I/O pBufferDesc
		PKMVERTEXBUFFER ^̒_obt@fXNv^ւ̃|C^

Result:
	KMSTATUS_SUCCESS	_obt@J

--*/
KMSTATUS KMAPI
kmDiscardVertexBuffer(
		PKMVERTEXBUFFDESC pBufferDesc
	);


/*++
kmCreateTABuffer

proto type:
	KMSTATUS
	kmCreateTABuffer(
		IN	PKMVERTEXBUFFDESC pBufferDesc,
		IN	KMINT32 TABuffer
		);

Description:
	^CANZ[^o͗pobt@(Native Data Buffer)At[obt@Ɋmۂ܂B
	̏ꍇ̒_f[^o^́A kmStartVertexStripDirect, kmSetVertexDirect, kmRenderDirectgp
	^CANZ[^֒ڃf[^ނƂɂĎ܂B
	ЂƂ̃AvP[V kmCreateVertexBuffer  kmCreateTABuffer 𓯎Ɏgp邱Ƃ͂ł܂B
Arguments:
	IN	TABuffer	^CANZ[^óiPowerVRlCeCuf[^jۑobt@̃TCYioCgjB
			
Result:
	KMSTATUS_SUCCESS			_f[^obt@mې
	KMSTATUS_NOT_ENOUGH_MEMORY	eʂȂ

--*/

KMSTATUS KMAPI
kmCreateTABuffer(
		IN	PKMVERTEXBUFFDESC pBufferDesc,
		IN	KMINT32 TABuffer
	);

/*++
kmFlushVertexBuffer

proto type:
	KMSTATUS
	kmFlushVertexBuffer(
		IN	KMLISTTYPE ListType,
		);

Description:
	w胊Xg^CvVertexBufferFlush܂BIɂ͎w胊XgDMA]Jn܂B
	{֐́AႦCLX1ŃXgOpaque瑗邱Ƃ𗘗pAXg𑗂邱ƂŁAOpaqueXg
	gpVertexBuffer̗eʂߖ񂷂ꍇȂǂɎgp܂B{֐́AVertexDirectn̊֐ƕp邱Ƃ
	ł܂B܂A{֐Ă΂ꂽ_ŁA܂ODMA]IĂȂꍇADMAȊ҂킹܂B
	gp̂Ƃ͂Ȃׂ҂킹Ȃ悤ɒӂĂB
	
Arguments:
	IN	ListType		_f[^Xgw肵܂Bȉ̂ꂩwł܂B
						KMLISTTYPE	KM_OPAQUE_POLYGON	= 0	// s|S
									KM_OPAQUE_MODIFIER	= 1	// sft@CA{[
									KM_TRANS_POLYGON	= 2	// ^|S
									KM_TRANS_MODIFIER	= 3	// ^ft@CA{[

Result:
	KMSTATUS_SUCCESS	ݒ萬

--*/

KMSTATUS KMAPI
kmFlushVertexBuffer(
		IN	KMLISTTYPE ListType
		);

/*++
kmStartVertexStrip

proto type:
	KMSTATUS
	kmStartVertexStrip( 
			PKMVERTEXBUFFDESC pBufferDesc
		);

Description:
	kmSetVertexRenderStateykmSetModifierRenderStateŐݒ肳ꂽKMVERTEXCONTEXT
	O[op[^𐶐AS̒_f[^obt@̂ꂩ֏݂܂B
	ޒ_f[^obt@́A KMVERTEXCONTEXTListTypeo猈肳܂B

	ӁFŏރO[op[^̌`kmSetVertexRenderStateŐݒ肵
		  KMVERTEXCONTEXT猈肳܂Bŏ񂾃O[op[^ƁA
		  ɑkmSetVertexŏޒ_p[^	`̑gݍ킹Ȃꍇ
		  ͕ۏ؂܂B

	<{֐͍v邽InlineWJ}NƂĒ`܂B>

Arguments:
	IN	pBufferDesc

Result:
	KMSTATUS_SUCCESS		O[op[^ݐ
	KMSTATUS_NOT_ENOUGH_MEMORY	_f[^obt@̗eʂȂ

--*/
KMSTATUS KMAPI
kmStartVertexStrip( 
		IN	PKMVERTEXBUFFDESC pBufferDesc
	);

/*++
kmStartVertexStripDirect

proto type:
	KMSTATUS
	kmStartVertexStripDirect(VOID);

Description:
	kmSetVertexRenderStateykmSetModifierRenderStateŐݒ肳ꂽ
	KMVERTEXCONTEXTO[op[^𐶐āAgvi^CANZ[^j֒ڏ݂܂B
	gvi^CANZ[^jɑ΂ẮAV[̒ł́AO[op[^ƒ_f[^́A
	_̎(Opaque Polygon, Opaque Modifier, Translucent Polygon, Translucent Modifier)
	܂Ƃ߂ē͂Kv܂B

	ӁF	ŏރO[op[^̌`kmSetVertexRenderStateŐݒ肵 
			KMVERTEXCONTEXT猈肳܂Bŏ񂾃O[op[^ƁA
			ɑkmSetVertexŏޒ_p[^̌`̑gݍ킹Ȃꍇ̓
			ۏ؂܂B

		<{֐͍v邽InlineWJ}NƂĒ`܂B>

Arguments:
	IN	pBufferDesc		KMVERTEXBUFFDESC^̒_obt@fXNv^ւ̃|C^łB

Result:
	KMSTATUS_SUCCESS		O[op[^ݐ

--*/

KMSTATUS KMAPI
kmStartVertexStripDirect(VOID);

/*++
kmSetVertex

proto type:
	KMSTATUS
	kmSetVertex(
			PKMVERTEXBUFFDESC pBufferDesc,
			PVOID pVertex,
			KMVERTEXTYPE VertexType,
			KMINT32 StructSize
		);

Description:
	pVertexŎw肳ꂽ_f[^\̂̊e_f[^AS̒_f[^obt@̂ꂩ֏݂܂B
	ޒ_f[^obt@́A KMVERTEXCONTEXTListTypeo猈肳܂B

	<{֐͍v邽InlineWJ}NƂĒ`܂B>

Arguments:
	IN	pBufferDesc		KMVERTEXBUFFDESC^̒_obt@fXNv^ւ̃|C^łB
	IN	pVertex			_f[^\̂ւ̃|C^łB
	IN	VertexType		_f[^̃f[^^Cv܂BL̂ꂩw肵܂B
						KM_VERTEXTYPE_00			// _f[^ Type 0
						KM_VERTEXTYPE_01			// _f[^ Type 1
						KM_VERTEXTYPE_02			// _f[^ Type 2
						KM_VERTEXTYPE_03			// _f[^ Type 3
						KM_VERTEXTYPE_04			// _f[^ Type 4
						KM_VERTEXTYPE_05			// _f[^ Type 5
						KM_VERTEXTYPE_06			// _f[^ Type 6
						KM_VERTEXTYPE_07			// _f[^ Type 7
						KM_VERTEXTYPE_08			// _f[^ Type 8
						KM_VERTEXTYPE_09			// _f[^ Type 9
						KM_VERTEXTYPE_10			// _f[^ Type 10
						KM_VERTEXTYPE_11			// _f[^ Type 11
						KM_VERTEXTYPE_12			// _f[^ Type 12
						KM_VERTEXTYPE_13			// _f[^ Type 13
						KM_VERTEXTYPE_14			// _f[^ Type 14
						KM_VERTEXTYPE_15			// _f[^ Type 15
						KM_VERTEXTYPE_16			// _f[^ Type 16

						KMVERTEX?? RgɂĂΗǂ̂ɁDDD

	IN	StructSize		_f[^̃f[^^CvTCY܂B_f[^Ɏgp^Cvɍ킹āA
						sizeof(KMVERTEX01)̗lɎw肵ĂB


Result:
	KMSTATUS_SUCCESS		_f[^ݐ
	KMSTATUS_NOT_ENOUGH_MEMORY	_f[^obt@̗eʂȂ

--*/

KMSTATUS KMAPI
kmSetVertex(
		IN	PKMVERTEXBUFFDESC pBufferDesc,
		IN	PVOID pVertex,
		IN	KMVERTEXTYPE VertexType,
		IN	KMINT32 StructSize
	);

/*++
kmSetVertexDirect

proto type:
	KMSTATUS
	kmSetVertexDirect(
			PVOID pVertex,
			KMVERTEXTYPE VertexType,
			KMINT32 StructSize
		);

Description:
	pVertexŎw肳ꂽ_f[^\̂̊e_f[^Agvi^CANZ[^j֒ڏ݂܂B
	gvi^CANZ[^jɑ΂ẮAV[̒ł́AO[op[^ƒ_f[^́A
	_̎(Opaque Polygon, Opaque Modifier, Translucent Polygon, Translucent Modifier)
	܂Ƃ߂ē͂Kv܂B

	ӁF	ŏޒ_p[^̌`ƁȂOkmSetVertexRenderStateŐݒ肵O[op[^̌`
			gݍ킹Ȃꍇ͕̓ۏ؂ȂB

		<{֐͍v邽InlineWJ}NƂĒ`܂B>

Arguments:
	IN	pVertex			_f[^\̂ւ̃|C^łB
	IN	VertexType		_f[^̃f[^^Cv܂BL̂ꂩw肵܂B
						KM_VERTEXTYPE_00			// _f[^ Type 0
						KM_VERTEXTYPE_01			// _f[^ Type 1
						KM_VERTEXTYPE_02			// _f[^ Type 2
						KM_VERTEXTYPE_03			// _f[^ Type 3
						KM_VERTEXTYPE_04			// _f[^ Type 4
						KM_VERTEXTYPE_05			// _f[^ Type 5
						KM_VERTEXTYPE_06			// _f[^ Type 6
						KM_VERTEXTYPE_07			// _f[^ Type 7
						KM_VERTEXTYPE_08			// _f[^ Type 8
						KM_VERTEXTYPE_09			// _f[^ Type 9
						KM_VERTEXTYPE_10			// _f[^ Type 10
						KM_VERTEXTYPE_11			// _f[^ Type 11
						KM_VERTEXTYPE_12			// _f[^ Type 12
						KM_VERTEXTYPE_13			// _f[^ Type 13
						KM_VERTEXTYPE_14			// _f[^ Type 14
						KM_VERTEXTYPE_15			// _f[^ Type 15
						KM_VERTEXTYPE_16			// _f[^ Type 16

						KMVERTEX?? RgɂĂΗǂ̂ɁDDD

	IN	StructSize		_f[^̃f[^^CvTCY܂B_f[^Ɏgp^Cvɍ킹āA
						sizeof(KMVERTEX01)̗lɎw肵ĂB
Result:
	KMSTATUS_SUCCESS		_f[^ݐ

--*/

KMSTATUS KMAPI
kmSetVertexDirect(
		IN	PVOID 				pVertex,
		IN	KMVERTEXTYPE		VertexType,
		IN	KMINT32				StructSize
	);


/*++
kmSetEndOfListDirect

proto type:
	KMSTATUS
	kmSetEndOfListDirect( VOID );

Description:
	̎ނ̃Xg̏IAHW(^CANZ[^)֒ڒʒm܂BHW(^CANZ[^)ɑ΂ẮA
	V[̒ł́AO[op[^ƒ_f[^́A_̎(OpaquePolygon,OpaqueModifier
	TranslucentPolygon,TranslucentModifier)ɂ܂Ƃ߂ē͂Kv܂BS̒_́Aꂼ̍Ō
	kmSetEndOfListDirect𔭍sāAݓo^̒_̎ނIƂʒm܂B
	́AkmSetVertexgpĒ_o^sĂꍇ͕Kv܂B

Arguments:
	None

Result:
	KMSTATUS_SUCCESS		ʒm

--*/

KMSTATUS KMAPI
kmSetEndOfListDirect( VOID );


/*++
kmRender

proto type:
	KMSTATUS
	kmRender( VOID );

Description:
	S̒_f[^obt@ׂĂɑ΂āAPV[̒_f[^̓o^IƂ_Ђɒʒm܂B
	_Ђ́AobNobt@ɑ΂郌_OJn܂
	iIɂ́AS̒_f[^obt@"End Of List"Control ParameterADMAɂ
	gvi^CANZ[^j֑荞݂܂jB

Arguments:
	None

Result:
	KMSTATUS_SUCCESS		ʒm

--*/

KMSTATUS KMAPI
kmRender( VOID );

/*++
kmRenderDirect

proto type:
	KMSTATUS
	kmRenderDirect(VOID);

Description:
	gvi^CANZ[^jɑ΂āAPV[̒_f[^̓o^IƂ_Ђɒʒm܂B
	_Ђ́AobNobt@ɑ΂郌_OJn܂iIɂ́A"End Of List"Control Parameter
	^CANZ[^֑荞݂܂jB

Arguments:
	None

Result:
	KMSTATUS_SUCCESS		ʒm

--*/

KMSTATUS KMAPI
kmRenderDirect(VOID);

/*++
kmRenderTexture

proto type:
	KMSTATUS
	kmRenderTexture(	
			PKMSURFACEDESC pTextureSurface
		);

Description:
	S̒_f[^obt@ׂĂɑ΂āAPV[̒_f[^̓o^IƂ_Ђɒʒm܂B
	_Ђ́Aw肳ꂽeNX`ɑ΂郌_OJn܂BiIɂ́AS̒_f[^obt@
	"End Of List"Control ParameterADMAɂĂgvi^CANZ[^j֑荞݂܂Bj
	ȂA`Ɏw肷eNX`́ARectangle/Stride`łȂ΂Ȃ܂B

Arguments:
	OUT	pTextureSurface		_Oʂi[eNX`łB

Result:
	KMSTATUS_SUCCESS			ʒm
	KMSTATUS_INVALID_TEXTURE	ȃeNX`w肵

--*/

KMSTATUS KMAPI
kmRenderTexture(
		PKMSURFACEDESC pTextureSurface
	);

/*++
kmRenderTextureDirect

proto type:
	KMSTATUS
	kmRenderTextureDirect(
			PKMSURFACEDESC pTextureSurface
		);

Description:
	gvi^CANZ[^jɑ΂āAPV[̒_f[^̓o^IƂ_Ђɒʒm܂B
	_Ђ́Aw肳ꂽeNX`ɑ΂郌_OJn܂iIɂ́A"End Of List"
	Control Parameter^CANZ[^֑荞݂܂jB
	ȂAw肷eNX`́ARectangle/Stride`łȂ΂Ȃ܂B

Arguments:
	OUT	pTextureSurface		_Oʂi[eNX`łB

Result:
	KMSTATUS_SUCCESS		ʒm
	KMSTATUS_INVALID_TEXTURE	ȃeNX`w肵

--*/

KMSTATUS KMAPI
kmRenderTextureDirect(
		PKMSURFACEDESC pTextureSurface
	);

/*++
kmSetEORCallback

proto type:

	KMSTATUS 
	kmSetEORCallback(
			PKMCALLBACKFUNC pEORCallback,
			PVOID pCallbackArguments
		);

Description:
	_OIɌĂ΂R[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID EORCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pEORCallback	_OIɌĂ΂֐̃|C^w肵܂B
	IN	pCallbackArguments
						callback Ɍďo֐֓nAւ̃|C^w肵܂B


Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS  KMAPI
kmSetEORCallback(
		PKMCALLBACKFUNC pEORCallback,
		PVOID 			pCallbackArguments
	);

/*++
kmSetVSyncCallback

proto type:
	KMSTATUS
	kmSetVSyncCallback(
			PKMCALLBACKFUNC pVSyncCallback,
			PVOID pCallbackArguments
		);

Description:
	AԁiVsyncj˓ɌĂяoR[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID VSyncCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pVSyncCallback	Vsync˓ɌĂ΂֐̃|C^w肵܂B
	IN	pCallbackArguments
						callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetVSyncCallback(
		PKMCALLBACKFUNC pVSyncCallback,
		PVOID 			pCallbackArguments
	);

/*++
kmSetHSyncCallback

proto type:
	KMSTATUS
	kmSetHSyncCallback(
			PKMCALLBACKFUNC pHSyncCallback,
			PVOID pCallbackArguments
		);

Description:
	AԁiHsyncj˓ɌĂяoR[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

	VOID HSyncCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pHSyncCallback		Hsync˓ɌĂ΂֐̃|C^w肵܂B

	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
							KmSetHSyncLine Ŏw肵Cԍ͓nȂ̂ŁA
							kmSetHSyncLine Őݒ肵l̃|C^̈ɕێ邩A
							܂́AkmGetCurrentScanline()gpāA݂ Scanline 擾ĂB

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetHSyncCallback(
		PKMCALLBACKFUNC pHSyncCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetHSyncLine

proto type:
	KMSTATUS
	kmSetHSyncLine(
			KMINT32 nInterruptLine
		);

Description:
	\CڂŊ荞݂Nw肵܂B 

Arguments:
	IN	nInterruptLine	CڂŊ荞݂Nw肵܂B0`240/480̒lݒ肵ĂB 

Result:
	KMSTATUS_SUCCESS			ݒ萬
	KMSTATUS_ILLEGAL_PARAMETER	ls

--*/

KMSTATUS KMAPI
kmSetHSyncLine(
		KMINT32 nInterruptLine
	);

/*++
kmGetCurrentScanline

proto type:
	KMSTATUS
	kmGetCurrentScanline(
			PKMINT32 pScanline
		);

Description:
	݂H-SyncCǂݏo܂B 

Arguments:
	OUT	pScanline	݂H-SyncCi[KMINT32ւ̃|C^łB 

Result:
	KMSTATUS_SUCCESS			ݒ萬

--*/

KMSTATUS KMAPI
kmGetCurrentScanline(
		PKMINT32 pScanline
	);

/*++
kmSetTexOverflowCallback

proto type:
	KMSTATUS
	kmSetTexOverflowCallback(
			PKMCALLBACKFUNC pTexOverflowCallback,
			PVOID pCallbackArguments
		);

Description:
	eNX`cĂȂԂŁAeNX`o^悤ƂꍇɌĂ΂R[obN֐
	o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID TexOverflowCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pTexOverflowCallback	eNX`I[o[t[̃R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
	
Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetTexOverflowCallback(
		PKMCALLBACKFUNC pTexOverflowCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetStripOverRunCallback

proto type:
	KMSTATUS
	kmSetStripOverRunCallback (
			PKMCALLBACKFUNC	pStripOverRunCallback,
			PVOID			pCallbackArguments
		);

Description:
	StripBuffeȑcTCY̕\ԒɎStrip̃_OIȂꍇɌĂ΂
	R[obN֐o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

			VOID StripOverRunCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pStripOverRunCallback	R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetStripOverRunCallback (
		PKMCALLBACKFUNC	pStripOverRunCallback,
		PVOID			pCallbackArguments
	);

/*++
kmSetEndOfVertexCallback

proto type:
	KMSTATUS
	kmSetEndOfVertexCallback (
			PKMCALLBACKFUNC pEndOfVertexCallback,
			PKMVOID			pCallbackArguments
		);

Description:
	_Ђ烌_On[hEFAւ́APV[̃f[^]IꍇɌĂ΂R[obN֐
	o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

			VOID EndOfVertexCallbackFunc(PVOID pCallbackArguments);

	pCallbackArgumentsíjFo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pEndOfVertexCallback	R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetEndOfVertexCallback (
		PKMCALLBACKFUNC pEndOfVertexCallback,
		PKMVOID 		pCallbackArguments
	);

/*++
kmStopDisplayFrameBuffer

proto type:
	KMSTATUS
	kmStopDisplayFrameBuffer ( VOID )

Description:
	Frame Buffer̕\~܂BAACRTRg[\~߂邾ł̂ŁA
	Frame BuffeȑԂ͕ω܂B

Arguments:
	None
Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmStopDisplayFrameBuffer ( VOID );

/*++
kmGetVersionInfo

proto type:
	KMSTATUS
	kmGetVersionInfo(
			PKMVERSIONINFO pVersionInfo
		);

Description:
	Cũo[W擾܂B
	o[W\̂̓eɂĂ͕ʓr\̈ꗗB

Arguments:
	OUT	pVersionInfo	炩ߊmۂĂKMVERSIONINFO\̂ւ̃|C^܂B

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmGetVersionInfo(
		PKMVERSIONINFO pVersionInfo
	);

/*++
kmLoadTexture

proto type:

	KMSTATUS
	kmLoadTexture(
			PKMSURFACEDESC pSurfaceDesc,
			PKMDWORD pTexture,
			KMBOOLEAN fAutoMipMap,
			KMBOOLEAN fDither
		);

Description:
	kmCreateTextureSurfaceŃAP[geNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃eNX`ǂݍ݂܂B

Arguments:
	OUT	pSurfaceDesc	kmCreateTextureSurfaceŃAP[geNX`T[tFXłB
	IN	pTexture		C̃eNX`|C^łB
	IN	bAutoMipMap		IMIPMAP𐶐邩ǂw肵܂B
						TRUEw肳ꂽꍇɂ͎IMIPMAP𐶐܂B
	IN	bDither			MIPMAP̎w肵ꍇɁAɃfBUMIPMAP
						邩ǂw肵܂BTRUEw肳ꂽꍇ̓fBU܂B
						̃tObAutoMipMapTRUEw肳ꂽƂ̂ݗLłB

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
	KMSTATUS_INVALID_MIPMAPED_TEXTURE	MIPMAPłȂeNX`
										MIPMAPgp悤Ƃ

--*/
KMSTATUS KMAPI
kmLoadTexture(
		PKMSURFACEDESC pSurfaceDesc,
		PKMDWORD pTexture,
		KMBOOLEAN fAutoMipMap,
		KMBOOLEAN fDither
	);

/*++
kmFreeTexture

proto type:
	KMSTATUS
	kmFreeTexture(
			PKMSURFACEDESC pSurfaceDesc
		);

Description:
	w肵eNX`T[tFX܂B

Arguments:
	I/O	pSurfaceDesc	kmCreateTextureSurfaceŃAP[geNX`T[tFXłB

Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_PARAMETER		sAeNX`̎w肪s

--*/

KMSTATUS KMAPI
kmFreeTexture(
		PKMSURFACEDESC pSurfaceDesc
	);


/*++
kmGetFreeTextureMem

proto type:
	KMSTATUS
	kmGetFreeTextureMem(
		PKMUINT32 pSizeOfTexture,
		PKMUINT32 pMaxBlockSizeOfTexture
		);

Description:
	eNX`̎ceʂԂ܂B

Arguments:
	OUT	pSizeOfTexture
			eNX`̎ceʂԂKMDWORD̈ւ̃|C^łB
	OUT	pMaxBlockSizeOfTexture
			eNX`̋󂫃ubN̍őeʂԂKMDWORD̈ւ̃|C^łB
Result:
	KMSTATUS_SUCCESS		

--*/

KMSTATUS KMAPI
kmGetFreeTextureMem(
		PKMUINT32 pSizeOfTexture,
		PKMUINT32 pMaxBlockSizeOfTexture
	);

/*++
kmReLoadMipmap

proto type:
	KMSTATUS
	kmReLoadMipmap(
			PKMSURFACEDESC 	pSurfaceDesc,
			PKMVOID	 		pTexture,
			KMINT32	 		nMipmapCount
		);

Description:
	kmCreateTextureSurfaceŃAP[geNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃~bv}bveNX`㏑ǂݍ݂܂B

Arguments:
	I/O	pSurfaceDesc	kmCreateTextureSurfaceŃAP[geNX`T[tFXłB
						Reloadł

	IN	pTexture		C̃~bv}bveNX`|C^łB
						Reloadł

	IN	nMipmapCount	ǂݍރ~bv}bveNX`̃xw肵܂B
						L̂ꂩw肷邱Ƃł܂B

						nMipmapCount			Texture Size
						KM_MAPSIZE_1x1				   1x1
						KM_MAPSIZE_2x2				   2x2
						KM_MAPSIZE_4x4				   4x4
						KM_MAPSIZE_8x8				   8x8
						KM_MAPSIZE_16x16			  16x16
						KM_MAPSIZE_32x32			  32x32
						KM_MAPSIZE_64x64			  64x64
						KM_MAPSIZE_128x128			 128x128
						KM_MAPSIZE_256x256			 256x256
						KM_MAPSIZE_512x512			 512x512
						KM_MAPSIZE_1024x1024		1024x1024
	

Result:
	KMSTATUS_SUCCESS			
	KMSTATUS_INVALID_PARAMETER	p[^s
	KMSTATUS_INVALID_TEXTURE	ȃeNX`w肵

--*/
KMSTATUS KMAPI
kmReLoadMipmap(
		PKMSURFACEDESC 	pSurfaceDesc,
		PKMVOID		 	pTexture,
		KMINT32	 		nMipmapCount
	);

/*++
kmGetTexture

proto type:

	KMSTATUS
	kmGetTexture(
		PKMDWORD		pTexture,
		PKMSURFACEDESC	pSurfaceDesc
		);

Description:
	pSurfaceDescŎw肵eNX`̃eNX`A 
	pTextureŎw肳ꂽCɓǂݏo܂B
	o͂ɂ́AKAMUIeNX`tH[}bgɏ]16oCg̃wb_t܂B

Arguments:
	OUT	pTexture		C̃eNX`ۑ̈|C^łB
	IN	pSurfaceDesc	eNX`ۑĂeNX`T[tFXłB

Result:
	KMSTATUS_SUCCESS					ǂݏo
	KMSTATUS_INVALID_ADDRESS			w肳ꂽeNX`T[tFX
										AP[gĂȂ

--*/

KMSTATUS KMAPI
kmGetTexture(
		PKMDWORD		pTexture,
		PKMSURFACEDESC	pSurfaceDesc
	);


/*++
kmGarbageCollectTexture

proto type:

	KMSTATUS
	kmGarbageCollectTexture(VOID);

Description:
	t[obt@̃Kx[WRNVs܂B

Arguments:

Result:
	KMSTATUS_SUCCESS					Kx[WRNV
	KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmGarbageCollectTexture(KMVOID);



/*++
kmSetFramebufferTexture

proto type:
	KMSTATUS 
	kmSetFramebufferTexture(
		IN	OUT	PKMSURFACEDESC	pSurfaceDesc
	);

Description:
	t[obt@̏AeNX`pSurfaceDescɓǂݏo܂B
	Õt[obt@̓eAStride-Rectanglar-TextureƂSurfaceDescɐݒ肳܂B
	SurfaceDescgpăeNX`}bv邱ƂɂAÕt[obt@
	̓eeNX`ƂĎgp邱Ƃł܂B
	eNX`ƂĎgp悤Ƃt[obt@́AL̐ݒłKv܂B
	EkmSetDisplayModeŁABitDepthƂāAKM_DSPBPP_ARGB1555,KM_DSPBPP_ARGB4444,KM_DSPBPP_RGB565
	@̂Âꂩw肳Ă邱ƁB

Arguments:
	IN	OUT	pSurfaceDesc	KMSURFACEDESC \̗̂̈|C^łB
							t[obt@̏񂪕Ԃ܂B

Result:
		KMSTATUS_SUCCESS				t[obt@̏ǂݏo
		KMSTATUS_INVALID_TEXTURE_TYPE	݂̃t[obt@̐ݒ̓eNX`ƂĎgpłȂ

Sample:
	kmSetStrideWidth(nScreenWidth);					// Set screen width
	....(Setup vertex)....
	kmRender();										// Generate previous Frame-Buffer
	kmSetFramebufferTexture(pSurfaceDesc);			// Get Framebuffer information
	VertexContext.pTextureSurfaceDesc	= &pSurfaceDesc;
	kmProcessVertexRenderState(&VertexContext);		// Use Framebuffer as texture
	kmSetVertexRenderState(&VertexContext);			// Set new vertex-context
	....(Setup vertex)....
	kmRender();										// Render!!

--*/

KMSTATUS KMAPI
kmSetFramebufferTexture(
		PKMSURFACEDESC	pSurfaceDesc
	);


/*++
kmLoadVQCodebook

proto type:

	KMSTATUS
	kmLoadVQCodebook(
			PKMSURFACEDESC pSurfaceDesc,
			PKMDWORD pTexture
		);

Description:
	pSurfaceDescŎw肳ꂽVQeNX`T[tFXɁApTextureŎw肳ꂽ
	CVQeNX`̃R[hubN݂̂ǂݍ݂܂B
	[hς݂VQeNX`́AR[hubN(800hoCg)݂̂
	J[pbgʂoƂɎgp܂B

Arguments:
	OUT	pSurfaceDesc	kmCreateTextureSurfaceŃAP[geNX`T[tFXłB
						̃T[tFX̃JeŚAKM_TEXTURE_VQ܂KM_TEXTURE_VQ_MM
						̂ǂ炩łȂ΂Ȃ܂B
	IN	pTexture		C̃eNX`iR[hubNj|C^łB
						͊SVQeNX`łKv͂܂񂪁A
						ȂƂ擪800hoCg̃R[hubN܂łKv܂B

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadVQCodebook(
		PKMSURFACEDESC	pSurfaceDesc,
		PKMDWORD		pTexture
	);


/*++
kmCreateContiguousTextureSurface

proto type:
	KMSTATUS 
	kmCreateContiguousTextureSurface(
			PPKMSURFACEDESC	ppSurfaceDesc,
			KMINT32			nTexture,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	t[obt@̘AAhẌɁAɕ̃eNX`pSurfacemۂ܂B
	́ATile AcceleratorYUVRo[^gpāAAĕYUV422`̃eNX`
	ǂݍނƂɎgp܂B(kmLoadYUVTextureQƂ)
	YUV422ȊÕeNX`pSurface̊mۂɂgp邱Ƃł܂B

	ȂAARC1ł́AAPIVQ,VQ-mipmap,Twiddled-mipmap̃T[tFXmۂ
	Ƃ͂ł܂B

Arguments:
	IN	OUT	ppSurfaceDesc		KMSURFACEDESC \̂ւ̃|C^z̃|C^łB
								mۂ Texture Surface ̏񂪕Ԃ܂B
								KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nTexture				AĊmۂ Texture Surface ̐w肵܂B

	IN	nWidth, nHeight			eNX`̉TCYAcTCYw肵܂B
								nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
								ꂩłȂ΂Ȃ܂B

	IN	nTextureType			eNX`̌`w肵܂B
								ȉ̃JeSR[hAsNZtH[}bgR[h
								IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_TWIDDLED				// TwiddledtH[}bg
									KM_TEXTURE_TWIDDLED_MM			// TwiddledtH[}bgMipmap(ARC1ł͎wł܂)
									KM_TEXTURE_TWIDDLED_RECTANGLE	// Twiddled-Rectangle			(ARC1ł͎gpł܂)
									KM_TEXTURE_VQ					// VQktH[}bg			(ARC1ł͎wł܂)
									KM_TEXTURE_VQ_MM				// VQktH[}bgMipmap	(ARC1ł͎wł܂)
									KM_TEXTURE_PALETTIZE4			// 4bpppbg`				(ARC1ł͎gpł܂)
									KM_TEXTURE_PALETTIZE4_MM		// 4bpppbg`Mipmap	(ARC1ł͎gpł܂)
									KM_TEXTURE_PALETTIZE8			// 8bpppbg`				(ARC1ł͎gpł܂)
									KM_TEXTURE_PALETTIZE8_MM		// 8bpppbg`Mipmap	(ARC1ł͎gpł܂)
									KM_TEXTURE_RECTANGLE			// `
									KM_TEXTURE_STRIDE				// `iXgChwLj

								- sNZtH[}bgR[h
									KM_TEXTURE_ARGB1555
									KM_TEXTURE_RGB565
									KM_TEXTURE_ARGB4444
									KM_TEXTURE_YUV422				//	(ARC1ł͎gpł܂)
									KM_TEXTURE_BUMP					//	(ARC1ł͎gpł܂)

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmCreateContiguousTextureSurface(
	IN	OUT	PPKMSURFACEDESC	ppSurfaceDesc,
	IN		KMINT32			nTexture,
	IN		KMINT32			nWidth,
	IN		KMINT32			nHeight,
	IN		KMTEXTURETYPE	nTextureType
	);


/*++
kmLoadYUVTexture

proto type:

	KMSTATUS
	kmLoadYUVTexture(
		PPKMSURFACEDESC	ppSurfaceDesc,
		PKMDWORD		pTexture,
		KMINT32			nTexture,
		KMINT32			nFormat
		);

Description:
	kmCreateTextureSurface/kmCreateCombinedTextureSurface/kmCreateContiguousTextureSurface
	ŃAP[geNX`̗̈ɁApTextureŎw肳ꂽC
	YUV420-data/YUV422-dataANon-Twiddled YUV422eNX`ɕϊēǂݍ݂܂B
	CLX1 Tile Accelerator ɓĂ YUV-data converter gpāAϊȂ
	ǂݍ݂܂B

	YUV-data converter ̏o͂ Non-Twiddled ł邽߁AAPIŎw肷ǂݍݐ
	Texture Surface ̌`́Aȉ̂ꂩłȂ΂Ȃ܂B
		KM_TEXTURE_RECTANGLE | KM_TEXTURE_YUV422	// `
		KM_TEXTURE_STRIDE    | KM_TEXTURE_YUV422	// `iXgChwLj

	YUV-dataAxɘAēǂݍޏꍇ(nTexture > 1 ̎)́AX̃eNX`
	TCY16x16eNZłȂ΂Ȃ܂BAPIŎw肷ǂݍݐTexture Surface
	̃TCYwɂӂB
	܂Ȁꍇ́AǂݍݐTexture Surface̓t[obt@ŘAAhX
	AP[gĂ邱ƂKvłB"kmCreateContiguousTextureSurface" APIgp
	AP[gTexture Surfacew肵ĂB

Arguments:
	IN	ppSurfaceDesc	AP[gς݂̃eNX`T[tFXKMSURFACEDESC \̂ւ
						|C^z̃|C^łB
	IN	pTexture		CYUV420-data/YUV422-data|C^łB
	IN	nTexture		Aēǂݍ Texture ̐w肵܂B
						włĺAPUŜꂩłB
	IN	nFormat			ǂݍރf[^̌`w肵܂Bȉ̂ꂩw肵܂B
						KM_TEXTURE_YUV420		̓f[^YUV420-datał邱Ƃ܂B
						KM_TEXTURE_YUV422		̓f[^YUV422-datał邱Ƃ܂B

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadYUVTexture(
		PPKMSURFACEDESC	ppSurfaceDesc,
		PKMDWORD		pTexture,
		KMINT32			nTexture,
		KMINT32			nFormat
		);


#ifdef __cplusplus
}
#endif 

#endif
