//=============================================================================
//
// Copyright 1998 by Captivation Digital Laboratories, Inc.
// All Rights Reserved.
//
//=============================================================================
//
// "KRAD" -- Kamui Rendering/Animation Demonstration
//
// Common declarations used throughout the KRAD program.
//
//=============================================================================
//-----------------------------------------------------------------------------
// $Revision: 1 $
// $NoKeywords: $
//=============================================================================

#ifndef _KRAD_H_
#define _KRAD_H_

#include <assert.h>
#include <iostream.h>
#include <math.h>
#include <string.h>

#include "kamui.h"
#include "kalgebra.h"

//=============================================================================
//=============================================================================
//=============================================================================

// ------------------------------------ SOURCE CODE SANITY CHECK
//	This definition forces a warning if a new header file
//  didn't change the template guard name.
#ifdef _HEADERFILE_H_
#error _HEADERFILE_H_ DEFINED!!!!
#endif

// ------------------------------------ COMMON CONSTANTS
#ifndef NULL
const long NULL	= 0;
#endif

#ifndef TRUE
const int TRUE	= true;
const int FALSE	= false;
#endif

#ifndef ON
const int ON	= true;
const int OFF	= false;
#endif

#ifndef YES
const int YES	= true;
const int NO	= false;
#endif

#ifndef GOOD
const int GOOD	= true;
const int BAD	= false;
const int EVIL	= false;
#endif

// ------------------------------------ SIMPLE TYPES
//typedef	signed		int			int;
typedef	unsigned	int			uint;

typedef	signed		__int8		int8;
typedef	unsigned	__int8		uint8;

typedef	signed		__int16		int16;
typedef	unsigned	__int16		uint16;

typedef	signed		__int32		int32;
typedef	unsigned	__int32		uint32;

typedef	signed		__int64		int64;
typedef	unsigned	__int64		uint64;

// ------------------------------------ DEBUG MACROS / FUNCTIONS
#ifdef _DEBUG
	#define	IFDEBUG(x)	x
	#define IFNDEBUG(x)	((void)0)
#else
	#define IFDEBUG(x)	((void)0)
	#define IFNDEBUG(x) x
#endif

// ------------------------------------ DEBUG MACROS / FUNCTIONS
// to allow for future change...
#define	infoout cout

//=============================================================================
//=============================================================================	PROTOTYPES
//=============================================================================

// ------------------------------------ KRAD Program Entry Point
void kradmain (void);

//=============================================================================
//=============================================================================
//=============================================================================

#endif  // Headerfile Guard

//=============================================================================	END-OF-INCLUDE