/*----------------------------------------------*/
/*                                              */
/*      Ninja Library for Windows Header File   */
/*                                              */
/*          Create 1997-04-21 SEGA System R&D   */
/*                                              */
/*----------------------------------------------*/

#ifndef _NINJAWIN_H_
#define _NINJAWIN_H_

#include	<windows.h>
#include	<Ninja.h>


/*
 *  DEFINES / MACROS
 */

/******** BUTTON ***********************************************************/
#define NJD_DGT_KR  (1 << 31)                     /* Lever Right           */
#define NJD_DGT_KL  (1 << 30)                     /* Lever Left            */
#define NJD_DGT_KD  (1 << 29)                     /* Lever Down            */
#define NJD_DGT_KU  (1 << 28)                     /* Lever Up              */
#define NJD_DGT_B27 (1 << 27)                     /* Button 27             */
#define NJD_DGT_B26 (1 << 26)                     /* Button 26             */
#define NJD_DGT_B25 (1 << 25)                     /* Button 25             */
#define NJD_DGT_B24 (1 << 24)                     /* Button 24             */
#define NJD_DGT_B23 (1 << 23)                     /* Button 23             */
#define NJD_DGT_B22 (1 << 22)                     /* Button 22             */
#define NJD_DGT_B21 (1 << 21)                     /* Button 21             */
#define NJD_DGT_B20 (1 << 20)                     /* Button 20             */
#define NJD_DGT_B19 (1 << 19)                     /* Button 19             */
#define NJD_DGT_B18 (1 << 18)                     /* Button 18             */
#define NJD_DGT_B17 (1 << 17)                     /* Button 17             */
#define NJD_DGT_B16 (1 << 16)                     /* Button 16             */
#define NJD_DGT_B15 (1 << 15)                     /* Button 15             */
#define NJD_DGT_B14 (1 << 14)                     /* Button 14             */
#define NJD_DGT_B13 (1 << 13)                     /* Button 13             */
#define NJD_DGT_B12 (1 << 12)                     /* Button 12             */
#define NJD_DGT_B11 (1 << 11)                     /* Button 11             */
#define NJD_DGT_B10 (1 << 10)                     /* Button 10             */
#define NJD_DGT_B9  (1 <<  9)                     /* Button  9             */
#define NJD_DGT_B8  (1 <<  8)                     /* Button  8             */
#define NJD_DGT_B7  (1 <<  7)                     /* Button  7             */
#define NJD_DGT_B6  (1 <<  6)                     /* Button  6             */
#define NJD_DGT_B5  (1 <<  5)                     /* Button  5             */
#define NJD_DGT_B4  (1 <<  4)                     /* Button  4             */
#define NJD_DGT_B3  (1 <<  3)                     /* Button  3             */
#define NJD_DGT_B2  (1 <<  2)                     /* Button  2             */
#define NJD_DGT_B1  (1 <<  1)                     /* Button  1             */
#define NJD_DGT_B0  (1 <<  0)                     /* Button  0             */

#define NJD_DGT_ST NJD_DGT_B8                     /* Start Button          */
#define NJD_DGT_TA NJD_DGT_B0                     /* A Button              */
#define NJD_DGT_TB NJD_DGT_B1                     /* B Button              */
#define NJD_DGT_TC NJD_DGT_B2                     /* C Button              */
#define NJD_DGT_TX NJD_DGT_B3                     /* X Button              */
#define NJD_DGT_TY NJD_DGT_B4                     /* Y Button              */
#define NJD_DGT_TZ NJD_DGT_B5                     /* Z Button              */
#define NJD_DGT_TL NJD_DGT_B6                     /* L Button              */
#define NJD_DGT_TR NJD_DGT_B7                     /* R Button              */



/******** DEVICE ID *******************************************************/
#define NJD_DEV_NODEVICE       0                  /* Device Unconnected    */
#define NJD_DEV_SYSKEYBOARD    1                  /* System Keyboard       */
#define NJD_DEV_SYSMOUSE       2                  /* System Mouse          */
#define NJD_DEV_JOYSTICK       3                  /* Joystick              */
#define NJD_DEV_UNDEFINED    255                  /* Unknown Device        */

/******** PERIPHERALS TO USE   *********************************************/
#define NJD_PER_USESYSKEYBOARD (1 << 0)           /* System Keyboard       */
#define NJD_PER_USESYSMOUSE    (1 << 1)           /* System Mouse          */
#define NJD_PER_USEJOYSTICK    (1 << 2)           /* Joystick              */
#define NJD_PER_USEALL         (7)                /* All                   */

/******** PORT NUMBER ******************************************************/
#define NJD_PORT_SYSKEYBOARD   0                  /* System Keyboard       */
#define NJD_PORT_SYSMOUSE      1                  /* System Port           */
#define NJD_PORT_JOYSTICK1     2                  /* Joystick1             */
#define NJD_PORT_JOYSTICK2     3                  /* Joystick2             */
#define NJD_PORT_JOYSTICK3     4                  /* Joystick3             */
#define NJD_PORT_JOYSTICK4     5                  /* Joystick4             */
#define NJD_PORT_JOYSTICK5     6                  /* Joystick5             */
#define NJD_PORT_JOYSTICK6     7                  /* Joystick6             */
#define NJD_PORT_JOYSTICK7     8                  /* Joystick7             */
#define NJD_PORT_JOYSTICK8     9                  /* Joystick8             */
#define NJD_PORT_JOYSTICK9    10                  /* Joystick9             */
#define NJD_PORT_JOYSTICK10   11                  /* Joystick10            */
#define NJD_PORT_JOYSTICK11   12                  /* Joystick11            */
#define NJD_PORT_JOYSTICK12   13                  /* Joystick12            */
#define NJD_PORT_JOYSTICK13   14                  /* Joystick13            */
#define NJD_PORT_JOYSTICK14   15                  /* Joystick14            */
#define NJD_PORT_JOYSTICK15   16                  /* Joystick15            */
#define NJD_PORT_JOYSTICK16   17                  /* Joystick16            */


/******** USER FUNCTION RETURN VALUE ***************************************/
#define NJD_USER_CONTINUE      0           /* Continuing njUserMain call  */
#define NJD_USER_EXIT         -1           /* Call njUserExit and exit    */

/*
 *  TYPEDEFS
 */

/******** PERIPHERAL DATA STRUCTURE ****************************************/
typedef struct {
	Uint32 id;                                 /* DVICE ID                 */
	Uint32 on;                                 /* Key currently pressed    */
	Uint32 off;                                /* Key currently unpressed  */
	union {
		Uint32 push;                           /* Key just pressed now     */
		Uint32 press;
	};
	union {	
		Uint32 pull;                           /* Key just unpressed now   */
		Uint32 release;
	};
	Sint16 x;                                  /* axis dataX(-32768`32767)*/
	Sint16 y;                                  /* axis dataY(-32768`32767)*/
	Sint16 z;                                  /* axis dataZ(-32768`32767)*/
	Sint16 r;                                  /* axis dataR(-32768`32767)*/
	Sint16 u;                                  /* axis dataU(-32768`32767)*/
	Sint16 v;                                  /* axis dataV(-32768`32767)*/
	Sint8* name;                               /* DEVICE NAME              */
	void* extend;                              /* Extended data            */
/* internal use; */
	Uint32 old;                                /* Key previously pressed   */
} NJS_PERIPHERAL;



/*
 *  GLOBAL DECLARATIONS
 */


/************************/
/*	 User Function		*/
/************************/

void njUserInit(void);
Sint32 njUserMain(void);
void njUserExit(void);

/************************/
/*	 Peripheral 		*/
/************************/

void njPrintPeripheralInfo(Int loc, Uint32 port);
NJS_PERIPHERAL* njGetPeripheral(Uint32 port);

/************************/
/*	 Windows 			*/
/************************/

HWND njGetWindowHandle(void);
HINSTANCE njGetInstance(void);



#endif /* _NINJAWIN_H_ */
